package com.xynet.marketing.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * 会员优惠券表
 *
 * @author hechunping
 * @date 2025/2/17
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@TableName("marketing_member_coupon")
public class MemberCoupon implements Serializable {

    @TableId(type = IdType.AUTO)
    private Integer id;


    /**
     * 商户id
     */
    private Integer mercId;

    /**
     * 第三方会员id
     */
    private String thirdMemberId;

    private Integer couponId;

    private String couponName;

    private Boolean isAllDevice;

    private Boolean isAllGoods;

    private LocalDate validStartDate;

    private LocalDate validEndDate;

    private Integer useMinPrice;

    private String type;

    private String price;

    private String status;

    private String useOrderId;

    private LocalDateTime useTime;

    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @TableField(fill = FieldFill.UPDATE)
    private LocalDateTime updateTime;

    private LocalDate createDate;

    private String createOrderId;

    private String remark;
}
